
#A New Battle Engine for MLD
#Based on the TileEngine




label Battle1:
    "Time for a battle!"

python:    
    params = Struct(
    geometry = TileEngine.ISOMETRIC,
    movement_style = UnitEngine.MP,
    movement_directions = 4,
    allow_moving_through_units = False,
    always_confirm_end_turn = True,
    moving_sprite_status="",
    start = True)


# Get the geometry-specific definitions
call SetupDefinitions from _CombatDemo_SetupDefinitions
# Define the map
call czexamap from _CombatDemo_CombatMap
    
#call screen cal1

python:
    e = TacticsCombat(map=map,
          tilewidth=tilewidth,
          tileheight=tileheight,
          background="blue",
          show_cursor=True,
          cursor_sprite=cursor_sprite,
          move_square_highlight=move_square_highlight,
          act_square_highlight=act_square_highlight,
          movement_duration=1.0,
          unit_highlight=unit_highlight,
          unit_highlight_function=unit_highlight_function,
          **(params.__dict__))


  # Player units
    Comtron1 = e.Unit(
        name = "Yamato",
        sprite_base_name = "unitlightbot.png", # It doesn't matter that this image itself doesn't exist,
        character = YAMATO,
        direction_facing = e.DIR_NW,            # because it'll always have a direction inserted before the dot
        max_HP = 100,
        max_MP = 3,
        weapons = [ TacticsCombat.RIFLE ],
        items = [ ],
        selected_weapon = TacticsCombat.RIFLE,
        actions = {"action": e.ReturnActionFunction()},
        position = (4, 4),
        visible_by_allies = [ ],
        visible_by_enemies = [ ]
        )
    Comtron2 = e.Unit(
        name = "Rommel",
        sprite_base_name = "unitlightbot.png",
        character = ROMMEL,
        direction_facing = e.DIR_NW,
        max_HP = 100,
        max_MP = 3,
        weapons = [ TacticsCombat.MEDIKIT, TacticsCombat.RIFLE ],
        items = [ ],
        selected_weapon = TacticsCombat.MEDIKIT,
        actions = {"action": e.ReturnActionFunction()},
        position = (8, 1),
        visible_by_allies = [ ],
        visible_by_enemies = [ ]
        )
    
    Comtron3 = e.Unit(
        name = "Rommel",
        sprite_base_name = "unitlightbot.png",
        character = ROMMEL,
        direction_facing = e.DIR_NW,
        max_HP = 100,
        max_MP = 3,
        weapons = [ TacticsCombat.MEDIKIT, TacticsCombat.RIFLE ],
        items = [ ],
        selected_weapon = TacticsCombat.MEDIKIT,
        actions = {"action": e.ReturnActionFunction()},
        position = (9, 1),
        visible_by_allies = [ ],
        visible_by_enemies = [ ]
        )
    
    # Enemy units
    Daleks = [ ]
    for thisDalekNum in [1, 2]:
        Daleks.append( e.Unit(
            name = "Sovian Rifle %d" % thisDalekNum,
            sprite_base_name = "unit-dalek.png", # Also doesn't exist, but will have a direction inserted
            character = DALEK,
            controller = UnitEngine.ENEMY,
            info_string = "A strangely familiar enemy.\nTheir rifles have a\nrange of 4 squares.",
            direction_facing = e.DIR_SE,
            max_HP = 50,
            max_MP = 2,
            weapons = [ TacticsCombat.LASER ],
            items = [ ],
            selected_weapon = TacticsCombat.LASER,
            actions = {"attack": e.ReturnDalekAttackFunction()},
            position = (thisDalekNum, 0),
            visible_by_allies = [ ],
            visible_by_enemies = [ ]
            ) )

  # Start the game
    e.StartGame()

  # When we're done with the game, store whether we won or lost, but then delete the object
  # This lets rollback and saving the game work again <.<
    endMode = e.mode
    del(e)

if endMode == UnitEngine.VICTORY:
  "Woohoo! We beat those strange purple robots!"
else:
  "Oh dear, beaten up by a bunch of robots."
  "It must be being encased in those boxy blue suits that did it."
  "Time for another demo - or another go at this one?"

  return

  
#CHOICE BETWEEN ISO AND STRAIGHT (TO BE DELETED)

init python:
  
    #ui.null(height=30)

  def SelectedIf(bool):
    if bool:
      return "selected_"
    else:
      return ""
  @renpy.curry
  def SetGeom(val):
    params.geometry = val
  @renpy.curry
  def SetMStyle(val):
    params.movement_style = val
  @renpy.curry
  def SetDirs(val):
    params.movement_directions = val
  @renpy.curry
  def SetMoveThru(val):
    params.allow_moving_through_units = val

  def StartUnitCombatDemo():
    params.start = True



##################### Shared combat demo code #####################

label SetupDefinitions:
if params.geometry == TileEngine.ISOMETRIC:
  jump IsometricDefinitions

label IsometricDefinitions:
  python:
    move_square_highlight = ("tile-highlight-iso-blue.png","tile-highlight-iso-blue-selected.png")
    act_square_highlight = ("tile-highlight-iso-red.png", "tile-highlight-iso-red-selected.png")
    f = MyFilmstrip(framesize=(100,48), gridsize=(2,3), delay=0.1)
    unit_highlight = im.Alpha("tile-highlight-iso-green-animstrip.png", 0.5)
    unit_highlight_function = f.Create
    cursor_sprite = "cursor-iso.png"
    Geom = TileEngine.ISOMETRIC
    tilewidth = 100
    tileheight = 50

    # Provide the isometric definitions of the tiles
    tile = Struct(
      terrain_type = UnitEngine.TT_GROUND,
      lower = "tile-tiles-iso.png",
      upper = None)
    rock = Struct(
      terrain_type = UnitEngine.TT_GROUND,
      lower = "tile-rocks-iso.png",
      upper = None)
    grass = Struct(
      terrain_type = UnitEngine.TT_GROUND,
      lower = "tile-grass-iso.png",
      upper = None)
    wall = Struct(
      terrain_type = UnitEngine.TT_WALL,
      lower = None,
      upper = "abovetile-wall-iso.png")
    # Two different tree tiles are composed of grass+tree and tiles+tree
    gtree = Struct(
      terrain_type = UnitEngine.TT_WALL,
      lower = "tile-grass-iso.png",
      upper = "abovetile-tree.png")
    ttree = Struct(
      terrain_type = UnitEngine.TT_WALL,
      lower = "tile-tiles-iso.png",
      upper = "abovetile-tree.png")
  return




################################################################################################################################################
################################################################################################################################################
##########################################                  #############################################################################################
##########################################    MAPS    #############################################################################################
##########################################                  #############################################################################################
################################################################################################################################################
################################################################################################################################################
  

label polixmap:
python:
  map = [
     [c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass ), c(grass), c(grass), c(grass ), c(grass ), c(grass), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass ), c(grass), c(grass ), c(grass), c(grass ), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass ), c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass), c(grass), c(grass ), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass ), c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass), c(grass), c(grass ), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(gtree), c(gtree), c(gtree), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass ), c(grass), c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
    ]
return

label czexamap:
python:
  map = [
     [c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass ), c(grass), c(grass), c(grass ), c(grass ), c(grass), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass ), c(grass), c(grass ), c(tile), c(grass ), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass ), c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass), c(grass), c(grass ), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass), c(grass ), c(grass), c(grass ), c(tile), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass ), c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass), c(grass), c(grass ), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass), c(gtree), c(gtree), c(gtree), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
     [c(grass ), c(grass), c(grass), c(grass), c(grass ), c(grass), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass ), c(grass), c(grass )],
    ]
return


##################### Definition of the TacticsCombat object, used by the combat demo #####################
init python:
  class TacticsCombat(UnitEngine):
    # Constants available before instantiation:
    # Item categories
    RANGEDWEAPON = 1
    MELEEWEAPON = 2
    HEALITEM = 3

    # Weapons used by player and enemy
    RIFLE = Struct(
      name = "Rifle",
      type = RANGEDWEAPON,
      damage = 20
      #renpy.sound.play ("hit.wav")
      )
    LASER = Struct(
      name = "Laser",
      type = MELEEWEAPON,
      damage = 25
      #sound = ("hit.wav")
      )
    MEDIKIT = Struct(
      name = "Medikit",
      type = HEALITEM,
      health = 25
      #sound = ("hit.wav")
      )

    ################# INITIALISATION #################
    def __init__(self, **properties):
      # Do UnitEngine and TileEngine init
      UnitEngine.__init__(self, **properties)

      # Specify the callbacks
      self.callbacks.unit_destroyed = self.UnitDestroyed
      #self.callbacks.unit_attack=self.UnitAttack

      # Define the overlay
      self.unit_info = [
            (self.Tactics_ShowUnitController),
            self.ShowUnitName,     
            self.ShowUnitHP,
            (self.IsPlayerUnit, self.ShowUnitMP),
            #(self.IsPlayerUnit, self.ShowUnitActionsLeft),
            #self.ShowUnitPosition,
            (self.IsPlayerUnit, self.Tactics_ShowUnitWeapons),
            (self.IsNonPlayerUnit, self.Tactics_ShowEnemyInfo)
              ]
              
      #self.extra_unit_info = [
            #(self.Tactics_IsHumanPlayerUnit, self.Tactics_ShowUnitController),
            #self.ShowUnitName,     
            #self.ShowUnitHP,
            #(self.IsPlayerUnit, self.ShowUnitMP),
            #(self.IsPlayerUnit, self.ShowUnitActionsLeft),
            #self.ShowUnitPosition,
            #(self.IsPlayerUnit, self.Tactics_ShowUnitWeapons),
            #(self.IsNonPlayerUnit, self.Tactics_ShowEnemyInfo)
              #]

      # Add fields to the map
      for tx in range(self.gxmax):
        for ty in range(self.gymax):
          self.map[tx][ty].VisibleBy = [ ]

    ################# DISPLAY #################

    def Tactics_IsHumanPlayerUnit(self):
      return (self.selected_unit.controller is self.current_player) and (self.current_player.control is self.HUMAN)

    def Tactics_ShowUnitController(self):
      ui.hbox() # Put character name and icon side-by-side
      #engine_label("(" + self.selected_unit.character.name + ")", size=20, color=self.selected_unit.character.colour)
      ui.image("%s_icon.png" % self.selected_unit.character.name, xalign=.5)
      ui.close() # End of the character name-and-icon hbox
      
    #def Tactics_ShowUnitController

    def Tactics_ShowUnitWeapons(self):
      #engine_label("Weapons:", size=16)
      for thisWeapon in self.selected_unit.weapons:
        ui.hbox() # Item name, select button
        engine_label(thisWeapon.name, size=16, yalign=0.5)
        if self.selected_unit.selected_weapon == thisWeapon:
          ui.button(clicked=None, xfill=False)
          engine_label("Selected", size=16) #, focus=None, default=False)
        else:
          ui.button(clicked=ui.returns(self.SelectWeapon(self, thisWeapon)), xfill=False)
          engine_label("Select", size=16)
        ui.close() # End of this equipment's hbox

    def Tactics_ShowEnemyInfo(self):
      engine_label(self.selected_unit.info_string, size=16)

    ################# CALLBACKS #################

    # SelectWeapon: curried, as I need to curry which weapon into it
    @renpy.curry
    def SelectWeapon(self, weapon):
      if weapon in self.selected_unit.weapons:
        self.selected_unit.selected_weapon = weapon
        if self.mode == self.ACTMODE:
          self.SetMode(self.UNITSELECTED)

    # ActionFunction: curried, as it's returned unbound by ReturnActionFunction
    @renpy.curry
    def ActionFunction(self):
      self.HighlightSquares(self.ActCriterion, self.act_square_highlight, self.ActionSquareClicked)

    def ReturnActionFunction(self):
      return self.ActionFunction(self)

    def ActCriterion(self, pos):
      if self.selected_unit.selected_weapon == self.RIFLE:
        # Rifles hit enemies anywhere
        return e.WithinNSpacesOf(3, pos) and e.ContainsNonPlayerUnit(pos)
      elif self.selected_unit.selected_weapon == self.MEDIKIT:
        # Medikits hit player units anywhere
        return self.ContainsPlayerUnit(pos)

        #THIS IS HOW YOU ADD ANIMATED BATTLE SEQUENCES
    def ActionSquareClicked(self, pos):
      thisItem = self.selected_unit.selected_weapon
      if thisItem.type in [self.RANGEDWEAPON, self.MELEEWEAPON]:
        thisSquare = self.map[pos[0]][pos[1]]
        if thisSquare.unit:
          self.selected_unit.TurnToFace(pos)
          self.Show()
          renpy.call_screen("battle_animation")
          #ui.image("battle.png", xalign=.5)
          #ui.image("%s_hit.png" % thisSquare.unit.name, xalign=.1)
          #ui.image("%s_anger.png" % self.selected_unit.character.name, xalign=.9)
          #self.selected_unit.character.object("Hit them!")
          self.DamageUnit(self.selected_unit.selected_weapon.damage, thisSquare.unit)
          self.FinishAction()
        else:
          self.selected_unit.character.object("Nothing found at %d,%d" % pos)
      elif thisItem.type == self.HEALITEM:
        thisSquare = self.map[pos[0]][pos[1]]
        if thisSquare.unit:
          self.selected_unit.TurnToFace(pos)
          thisSquare.unit.HP = min(thisSquare.unit.HP + thisItem.health, thisSquare.unit.max_HP)
          self.selected_unit.character.object("Hope you feel better.")
          self.FinishAction()
        else:                                                                                                                                                                                                                                                  
          self.selected_unit.character.object("There's nothing there...")

    # DalekAttack: curried, as it's returned unbound by ReturnDalekAttackFunction
    @renpy.curry
    def DalekAttack(self):
      # Lasers can hit an enemy up to 4 spaces away
      (unitx, unity), (thisx, thisy) = self.selected_unit.position, self.selected_unit.target_unit.position
      distFromTarget = abs(thisx - unitx) + abs(thisy - unity)
      if self.WithinNSpacesOf(4, self.selected_unit.target_unit.position):
        self.selected_unit.TurnToFace(self.selected_unit.target_unit)
        
        self.Show()
        #self.selected_unit.target_unit.character.object("Aargh! It shot me!")
        #ui.image("unit-dalek-cc.png", xalign=.9)
        #ui.image("%s_anger.png" % self.selected_unit.target_unit.character.object, xalign=.1)
        #ui.image("dalek_anger.png" % self.selected_unit.character.name, xalign=.1)
        self.DamageUnit(self.selected_unit.selected_weapon.damage,
                        self.selected_unit.target_unit)
        self.FinishAction() 
        renpy.call_screen("battle_animation")
        #ui.pausebehavior (1.0, result=False)

    def ReturnDalekAttackFunction(self):
      return self.DalekAttack(self)

    def UnitDestroyed(self, unit):
      if unit.controller is self.PLAYER:
        renpy.play("hit.wav")
        unit.character.object("I'm... done for now...")
      else:                                                                        
        if self.current_player is self.PLAYER:
          renpy.play("hit.wav")
          self.selected_unit.character.object("Yeah! We killed it!")
          
      #def UnitAttack(self, unit):
        #if unit.controller is self.PLAYER:
          #self.selected_unit.character.object("Die Human!")
        #else:                                                                        
          #if self.current_player is self.PLAYER:
            #self.selected_unit.character.object("No you!")


